package com.fjhx.purchase.service.arrival.impl;

import com.fjhx.purchase.entity.arrival.po.ArrivalDetail;
import com.fjhx.purchase.mapper.arrival.ArrivalDetailMapper;
import com.fjhx.purchase.service.arrival.ArrivalDetailService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.purchase.entity.arrival.vo.ArrivalDetailVo;
import com.fjhx.purchase.entity.arrival.dto.ArrivalDetailSelectDto;
import com.ruoyi.common.utils.wrapper.IWrapper;
import com.fjhx.purchase.entity.arrival.dto.ArrivalDetailDto;
import cn.hutool.core.bean.BeanUtil;

import java.math.BigDecimal;


/**
 * <p>
 * 到货明细单 服务实现类
 * </p>
 *
 * @author 
 * @since 2023-04-07
 */
@Service
public class ArrivalDetailServiceImpl extends ServiceImpl<ArrivalDetailMapper, ArrivalDetail> implements ArrivalDetailService {

    @Override
    public Page<ArrivalDetailVo> getPage(ArrivalDetailSelectDto dto) {
        IWrapper<ArrivalDetail> wrapper = getWrapper();
        wrapper.orderByDesc("ad", ArrivalDetail::getId);
        Page<ArrivalDetailVo> page = this.baseMapper.getPage(dto.getPage(), wrapper);
        return page;
    }

    @Override
    public ArrivalDetailVo detail(Long id) {
        ArrivalDetail ArrivalDetail = this.getById(id);
        ArrivalDetailVo result = BeanUtil.toBean(ArrivalDetail, ArrivalDetailVo.class);
        return result;
    }

    @Override
    public void add(ArrivalDetailDto arrivalDetailDto) {
        this.save(arrivalDetailDto);
    }

    @Override
    public void edit(ArrivalDetailDto arrivalDetailDto) {
        this.updateById(arrivalDetailDto);
    }

    @Override
    public void delete(Long id) {
        this.removeById(id);
    }

    /**
     * 统计到货明细总数
     * @param purchaseDetailId
     * @param businessId
     * @return
     */
    @Override
    public BigDecimal getSumCount(Long purchaseDetailId, Long businessId) {
        return baseMapper.getSumCount(purchaseDetailId,businessId);
    }

}
